
/******************************************/
/*                                        */
/* Class: VarArray                        */
/*                                        */
/******************************************/

public class VarArray {
  public int capacity;
  public int size;
  private Object[] buffer;

  /******************************************/
  /*                                        */
  /* Constructor: VarArray                  */
  /*                                        */
  /******************************************/

  public VarArray( int n )
  {
    capacity = n;
    size = 0;
    buffer = new Object[capacity];
  }

  public VarArray()
  {
    capacity = 100;
    size = 0;
    buffer = new Object[capacity];
  }

  /******************************************/
  /*                                        */
  /* Method: set                            */
  /*                                        */
  /******************************************/

  public void set( Object o, int i )
  {
    if (capacity <= i) {
      capacity *= 2;
      if (capacity <= i)
	capacity = i+1;
      
      Object[] b = new Object[capacity];
      for( int k=0; k<size; k++ )
	b[k] = buffer[k];
      buffer = b;
    }
    buffer[i] = o;
    if (size <= i)
      size = i+1;
  }

  /******************************************/
  /*                                        */
  /* Method: get                            */
  /*                                        */
  /******************************************/

  public Object get( int i )
  {
    return buffer[i];
  }

  /******************************************/
  /*                                        */
  /* Method: add                            */
  /*                                        */
  /******************************************/

  public void add( Object o )
  {
    set(o, size);
  }


  /******************************************/
  /*                                        */
  /* Method: toArray                        */
  /*                                        */
  /******************************************/

  public Object[] toArray ()
  {
    Object[] a = new Object[size];
    for( int k=0; k<size; k++ )
      a[k] = buffer[k];
    return a;
  }
}
